#!/usr/bin/env node
/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 915:
/***/ ((__unused_webpack_module, exports) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.default = {
    settingsFile: "backup-config.json",
    settings: {
        backupFile: "backup.json",
        keyFile: "key.json",
        databaseURL: "",
    }
};


/***/ }),

/***/ 468:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const _ = __importStar(__webpack_require__(804));
const admin = __importStar(__webpack_require__(54));
const utility_1 = __webpack_require__(317);
const firestore_1 = __importDefault(__webpack_require__(234));
const fileOperations_1 = __webpack_require__(116);
function normalizeField(value, db) {
    if (value instanceof admin.firestore.Timestamp) {
        return {
            "__datatype__": "timestamp",
            "value": { "seconds": value.seconds, "nanoseconds": value.nanoseconds }
        };
    }
    else if (value instanceof admin.firestore.GeoPoint) {
        return {
            "__datatype__": "geopoint",
            "value": { "latitude": value.latitude, "longitude": value.longitude }
        };
    }
    else if (value instanceof admin.firestore.DocumentReference) {
        return {
            "__datatype__": "documentRef",
            "value": value.path
        };
    }
    else if (Array.isArray(value)) {
        return value.map(subfield => normalizeField(subfield, db));
    }
    else if (typeof value === 'object' && value !== null) {
        return saveFields(value, db);
    }
    return value;
}
function saveFields(fields, db) {
    let result = {};
    if (_.isEmpty(fields)) {
    }
    else {
        for (let [key, value] of Object.entries(fields)) {
            result[key] = normalizeField(value, db);
        }
    }
    return result;
}
function saveDocument(document, db) {
    return __awaiter(this, void 0, void 0, function* () {
        let collections = yield saveCollections(document, db);
        let fields = yield document.get();
        let normalizedFields = saveFields(fields.data(), db);
        return { [document.id]: { "__fields__": normalizedFields, "__collections__": collections } };
    });
}
function saveCollection(collection, db) {
    return __awaiter(this, void 0, void 0, function* () {
        let documents = yield collection.listDocuments();
        let result = {};
        if (_.isEmpty(documents)) {
        }
        else {
            let queries = [];
            for (let document of documents) {
                queries.push(yield saveDocument(document, db));
            }
            result = Object.assign({}, ...queries);
        }
        return { [collection.id]: result };
    });
}
function saveCollections(currentRef, db) {
    return __awaiter(this, void 0, void 0, function* () {
        let collections = yield currentRef.listCollections();
        let result = {};
        if (_.isEmpty(collections)) {
        }
        else {
            let queries = [];
            for (let collection of collections) {
                queries.push(yield saveCollection(collection, db));
            }
            result = Object.assign({}, ...queries);
        }
        return result;
    });
}
function createBackup() {
    return __awaiter(this, void 0, void 0, function* () {
        const db = yield firestore_1.default();
        let sp = new utility_1.Spinner("Generating backup");
        sp.start();
        let backup = yield saveCollections(db, db);
        sp.end("", "");
        yield fileOperations_1.downloadBackup(backup);
    });
}
exports.default = createBackup;


/***/ }),

/***/ 487:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const firestore_1 = __importDefault(__webpack_require__(234));
const utility_1 = __webpack_require__(317);
function deleteDocument(document) {
    return __awaiter(this, void 0, void 0, function* () {
        deleteCollections(document);
        document.delete();
    });
}
function deleteCollection(collection) {
    return __awaiter(this, void 0, void 0, function* () {
        let documents = yield collection.listDocuments();
        for (let document of documents) {
            yield deleteDocument(document);
        }
    });
}
function deleteCollections(ref) {
    return __awaiter(this, void 0, void 0, function* () {
        let collections = yield ref.listCollections();
        for (let collection of collections) {
            yield deleteCollection(collection);
        }
    });
}
function deleteDatabase() {
    return __awaiter(this, void 0, void 0, function* () {
        const db = yield firestore_1.default();
        let sp = new utility_1.Spinner("Deleting database");
        sp.start();
        yield deleteCollections(db);
        sp.end("Database deleted successfully.");
    });
}
exports.default = deleteDatabase;


/***/ }),

/***/ 116:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.readBackup = exports.downloadBackup = exports.readKey = exports.readSettings = exports.createSettings = void 0;
const fs = __importStar(__webpack_require__(747));
const util = __importStar(__webpack_require__(669));
const constants_1 = __importDefault(__webpack_require__(915));
const utility_1 = __webpack_require__(317);
const readFile = util.promisify(fs.readFile);
const writeFile = util.promisify(fs.writeFile);
function createSettings() {
    return __awaiter(this, void 0, void 0, function* () {
        const jsonData = JSON.stringify(constants_1.default.settings, null, 4);
        let sp = new utility_1.Spinner("Creating settings file");
        sp.start();
        try {
            yield writeFile(constants_1.default.settingsFile, jsonData);
            sp.end('Settings file created successfully.');
        }
        catch (error) {
            sp.end(utility_1.red("Error: Unable to create settings file."));
            process.exit(1);
        }
    });
}
exports.createSettings = createSettings;
function readSettings() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const settingsData = yield readFile(constants_1.default.settingsFile);
            const settings = JSON.parse(settingsData.toString());
            return settings;
        }
        catch (error) {
            console.log("Unable to open settings file.");
            return {};
        }
    });
}
exports.readSettings = readSettings;
function readKey() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            let serviceAccount = yield readFile(constants_1.default.settings.keyFile);
            return JSON.parse(serviceAccount.toString());
        }
        catch (error) {
            console.log(utility_1.red("Error: Unable to open service key."));
            console.log(`No such file at path ${error.toString().match(/'.+'/g)}.`);
            process.exit(1);
        }
    });
}
exports.readKey = readKey;
function downloadBackup(data) {
    return __awaiter(this, void 0, void 0, function* () {
        const jsonData = JSON.stringify(data, null, 4);
        let sp = new utility_1.Spinner("Downloading backup");
        sp.start();
        try {
            yield writeFile(constants_1.default.settings.backupFile, jsonData);
            sp.end('Backup downloaded successfully.');
        }
        catch (error) {
            sp.end(utility_1.red("Error: Unable to download backup."));
            process.exit(1);
        }
    });
}
exports.downloadBackup = downloadBackup;
function readBackup() {
    return __awaiter(this, void 0, void 0, function* () {
        let sp = new utility_1.Spinner("Retrieving backup");
        sp.start();
        try {
            const data = yield readFile(constants_1.default.settings.backupFile);
            const jsonData = JSON.parse(data.toString());
            sp.end('Backup retrieved successfully.');
            return jsonData;
        }
        catch (error) {
            sp.end(utility_1.red("Error: Unable to retrieve backup."));
            console.log(`No such file at path ${error.toString().match(/'.+'/g)}.`);
            process.exit(1);
        }
    });
}
exports.readBackup = readBackup;


/***/ }),

/***/ 234:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const admin = __importStar(__webpack_require__(54));
const fileOperations_1 = __webpack_require__(116);
const constants_1 = __importDefault(__webpack_require__(915));
const utility_1 = __webpack_require__(317);
function loadSettings() {
    return __awaiter(this, void 0, void 0, function* () {
        const settings = yield fileOperations_1.readSettings();
        let mergedConf = Object.assign({}, constants_1.default.settings, settings);
        constants_1.default.settings.backupFile = mergedConf.backupFile;
        constants_1.default.settings.keyFile = mergedConf.keyFile;
        constants_1.default.settings.databaseURL = mergedConf.databaseURL;
    });
}
function initializeApp() {
    return __awaiter(this, void 0, void 0, function* () {
        const key = yield fileOperations_1.readKey();
        yield loadSettings();
        try {
            admin.initializeApp({
                credential: admin.credential.cert(key),
                databaseURL: constants_1.default.settings.databaseURL
            });
            return admin.firestore();
        }
        catch (error) {
            console.log(utility_1.red("Error: Unable to initialize Firebase services."));
            process.exit(1);
        }
    });
}
exports.default = initializeApp;


/***/ }),

/***/ 432:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const yargs_1 = __importDefault(__webpack_require__(585));
const prompt_sync_1 = __importDefault(__webpack_require__(852));
const createBackup_1 = __importDefault(__webpack_require__(468));
const restoreBackup_1 = __importDefault(__webpack_require__(122));
const deleteDatabase_1 = __importDefault(__webpack_require__(487));
const utility_1 = __webpack_require__(317);
const fileOperations_1 = __webpack_require__(116);
const constants_1 = __importDefault(__webpack_require__(915));
const prompt = prompt_sync_1.default({ sigint: true });
const argv = yargs_1.default.usage(`
${utility_1.orange("====== FIRESTORE DATABASE MANAGER ======")}

Usage: $0 [options]

If a configuration file is provided (${constants_1.default.settingsFile}), it should have the following structure:
{
    "backupFile": "...", --> *(default: "backup.json")
    "keyFile": "...",  --> *(default: "key.json")
    "databaseURL": "..." --> *(default: "https://<your_database_id>.firebaseio.com")
}

Key service file must be downloaded from your project configuration:
https://console.firebase.google.com/u/0/project/<your_database_id>/settings/serviceaccounts/adminsdk`)
    .option("i", {
    alias: "init-config",
    describe: `Create a default backup configuration file ('${constants_1.default.settingsFile}')`,
    type: "boolean",
})
    .option("g", {
    alias: "generate-backup",
    describe: "Generate a backup of a Firestore database",
    type: "boolean",
})
    .option("r", {
    alias: "restore-backup",
    describe: "Restore a backup of a Firestore database",
    type: "boolean",
})
    .option("d", {
    alias: "delete",
    describe: "Delete a Firestore database",
    type: "boolean",
})
    .check(function (argv) {
    let selected = utility_1.selectedOptions([argv.i, argv.g, argv.r, argv.d]);
    if (selected == 0) {
        throw 'Error: a valid option must be specified.';
    }
    if (selected > 1) {
        throw (new Error('Error: only one option must be specified.'));
    }
    return true;
})
    .alias("v", "version")
    .describe("version", "Show current version number")
    .help("h")
    .alias("h", "help")
    .describe("h", "Show available options")
    .showHelpOnFail(false, "Specify --help for available options").argv;
function main(argv) {
    return __awaiter(this, void 0, void 0, function* () {
        const databaseID = (yield fileOperations_1.readKey())["project_id"];
        constants_1.default.settings.databaseURL = `https://${databaseID}.firebaseio.com`;
        if (argv.i)
            yield fileOperations_1.createSettings();
        if (argv.g)
            yield createBackup_1.default();
        if (argv.r)
            yield restoreBackup_1.default();
        if (argv.d) {
            let resp = prompt(`Are you sure you want to delete ${utility_1.orange(databaseID)} collections? ${utility_1.blue("yes/[no]")}: `);
            if ("yes".includes(resp.trim().toLowerCase()) && resp !== "") {
                yield deleteDatabase_1.default();
            }
            else {
                console.log("Canceled operation.");
            }
        }
    });
}
main(argv);


/***/ }),

/***/ 122:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
const _ = __importStar(__webpack_require__(804));
const admin = __importStar(__webpack_require__(54));
const utility_1 = __webpack_require__(317);
const firestore_1 = __importDefault(__webpack_require__(234));
const fileOperations_1 = __webpack_require__(116);
function convertField(value, db) {
    if (typeof value === 'object' && value !== null && !_.isArray(value) && "__datatype__" in value) {
        let dt = value.__datatype__;
        let data = value.value;
        if (dt === "timestamp") {
            return new admin.firestore.Timestamp(data.seconds, data.nanoseconds);
        }
        else if (dt === "geoPoint") {
            return new admin.firestore.GeoPoint(data.latitude, data.longitude);
        }
        else if (dt === "documentRef") {
            return db.doc(data);
        }
    }
    else if (Array.isArray(value)) {
        return value.map(subfield => convertField(subfield, db));
    }
    else if (typeof value === 'object' && value !== null) {
        return restoreFields(value, db);
    }
    return value;
}
function restoreFields(fields, db) {
    let result = {};
    if (!_.isEmpty(fields)) {
        for (let [key, value] of Object.entries(fields)) {
            result[key] = convertField(value, db);
        }
    }
    return result;
}
function restoreDocument(document, ref, db) {
    return __awaiter(this, void 0, void 0, function* () {
        yield restoreCollections(document.__collections__, ref, db);
        let normalizedFields = restoreFields(document.__fields__, db);
        yield ref.set(normalizedFields);
    });
}
function restoreCollection(collection, ref, db) {
    return __awaiter(this, void 0, void 0, function* () {
        for (let [document, content] of Object.entries(collection)) {
            yield restoreDocument(content, ref.doc(document), db);
        }
    });
}
function restoreCollections(collections, ref, db) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!_.isEmpty(collections)) {
            for (let [collection, content] of Object.entries(collections)) {
                yield restoreCollection(content, ref.collection(collection), db);
            }
        }
    });
}
function restoreBackup() {
    return __awaiter(this, void 0, void 0, function* () {
        const db = yield firestore_1.default();
        const backup = yield fileOperations_1.readBackup();
        let sp = new utility_1.Spinner("Restoring backup");
        sp.start();
        yield restoreCollections(backup, db, db);
        sp.end('Backup restored successfully.');
    });
}
exports.default = restoreBackup;


/***/ }),

/***/ 317:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.selectedOptions = exports.Spinner = exports.orange = exports.red = exports.blue = void 0;
const lodash_1 = __importDefault(__webpack_require__(804));
const cli_spinner_1 = __importDefault(__webpack_require__(855));
const chalk_1 = __importDefault(__webpack_require__(242));
exports.blue = chalk_1.default.hex("#0078D4");
exports.red = chalk_1.default.hex("#FF0101");
exports.orange = chalk_1.default.hex("#F89B0C");
class Spinner {
    constructor(loadingMsg) {
        this.spinner = new cli_spinner_1.default.Spinner(`${exports.blue("%s ")} ${loadingMsg}...`);
        this.spinner.setSpinnerDelay(50);
    }
    start() {
        this.spinner.start();
    }
    end(endMsg = "", final = "\n") {
        this.spinner.stop();
        console.log(`${final}${endMsg}`);
    }
}
exports.Spinner = Spinner;
function selectedOptions(expressions) {
    let result = expressions.map(exp => exp ? 1 : 0);
    return lodash_1.default.sum(result);
}
exports.selectedOptions = selectedOptions;


/***/ }),

/***/ 242:
/***/ ((module) => {

module.exports = require("chalk");

/***/ }),

/***/ 855:
/***/ ((module) => {

module.exports = require("cli-spinner");

/***/ }),

/***/ 54:
/***/ ((module) => {

module.exports = require("firebase-admin");

/***/ }),

/***/ 747:
/***/ ((module) => {

module.exports = require("fs");

/***/ }),

/***/ 804:
/***/ ((module) => {

module.exports = require("lodash");

/***/ }),

/***/ 852:
/***/ ((module) => {

module.exports = require("prompt-sync");

/***/ }),

/***/ 669:
/***/ ((module) => {

module.exports = require("util");

/***/ }),

/***/ 585:
/***/ ((module) => {

module.exports = require("yargs");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__(432);
/******/ 	
/******/ })()
;
//# sourceMappingURL=index.js.map